﻿console.log('\n\nStarting validation\n');

var tv4 = require('tv4');
var fs = require('fs');
var path = require('path');


var getJSONDataFiles = function (path) {
    
    
    var stat = fs.lstatSync(path);
    if (stat.isFile())
        return [path];
    if (!stat.isDirectory())
        return [];
    return [].concat.apply([], fs.readdirSync(path).map(function (fname) {
        return getJSONDataFiles(path + '/' + fname);
    }));
    
    
   

};

var validateDataAndSchema = function (dir, datafiles) {
    
    
    
    var recursive = require('recursive-readdir');
    
    recursive(dir, function (err, files) {
        
        
        files.forEach(function (entry) {
            
            if (entry.indexOf(".schema.json") > -1) {
                
                datafiles.forEach(function (datafile) {
                    
                    var data = fs.readFileSync(datafile);
                    var datanb = removeBOM(data);
                    var jdata = JSON.parse(datanb);
                    schematype = jdata.$schema;
                    
                    
                    var schema = fs.readFileSync(entry);
                    var schemanb = removeBOM(schema);
                    var jschema = JSON.parse(schemanb);
                   // console.log(datafile);
                   // console.log(entry);
                    
                    if (jschema.id == schematype && typeof jschema.id !== 'undefined' && typeof schematype !== 'undefined') {
                        
                        
                        tv4.addSchema(jschema);
                        
                        var result = tv4.validateMultiple(jdata, jschema, true, true);
                        
                        console.log("Validate file " + datafile + " with Schema " + entry + ": " + result.valid);
                        
                        if (!(result.errors.length == 0)) {
                            console.log("\n\nErrors:");
                            console.log("\n\nValidation: " + result.errors.forEach(function (error) {
                                console.log("\n" + error.message + "\n" + error.dataPath);
                                
                                
                            }
                            ));
                        }
                        console.log("\n\n");
                    }
                });
               
            }
        });
        
        
    });
   
    
};

console.log("Current working directory: " + process.cwd() + "\n\n");
console.log(process.cwd());
var data = (getJSONDataFiles(process.cwd())).filter(function (path) {
    
    return /\.json$/.test(path)
});

validateDataAndSchema(process.cwd() , data);

function removeBOM(file) {
    
    var fts = file.toString();
    
    
    if (fts.charCodeAt(0) === 0xFEFF) {
        
        fts = fts.substr(1);
       
    }
    
    return fts;

}